#include <vector>

using std::vector;

class Itemset
{
public:
	Itemset(int item = 0);
	Itemset(int size, bool dummy);
	Itemset(const Itemset & iset1, const Itemset & iset2); // union of disjoint
	Itemset(const vector<int> & iset);
	Itemset(const Itemset & itemset);
	~Itemset();
	
	void intersect_into(const Itemset & iset1, const Itemset & iset2);
	
	int& operator[](int i);
	
	bool operator==(const Itemset & other) const;
	
	bool contains(int item) const;
	
	int size;
	int *iset;

};



struct ItemsetPtrComp
{
	bool operator() (const Itemset *lhs, const Itemset *rhs)
	{
		if (lhs->size < rhs->size)
			return true;
		else if (lhs->size > rhs->size)
			return false;
		else {
			for (int k=0; k<lhs->size; ++k) {
				if (lhs->iset[k] > rhs->iset[k])
					return false;
				else if (lhs->iset[k] < rhs->iset[k])
					return true;
			}
			return false;
		}
	}
};

typedef Itemset Attrset;
