#include <set>

using std::pair;
using std::set;


struct SimHeapNode
{
	SimHeapNode(double sim=0, int i=0, int j=0) : sim(sim), i(i), j(j) { };
	
	double sim;
	int i;
	int j;
};



class SimilarityMatrix
{
public:
	SimilarityMatrix(int n);
	SimilarityMatrix(const SimilarityMatrix & sim);
	~SimilarityMatrix();
	
	void init_row(int i);
	void delete_row(int i);
	void insert(int i, int j, double sim);
	
	pair<double, pair<int,int> > get_max() const;
	pair<double, pair<int,int> > *get_topk(int k) const;
	void get_topk(int k, int pos, pair<double, pair<int,int> > *topk, int & len) const;
	
private:
	void remove(int i, int j);
	void move_node(int from, int to);
	
private:
	int ** sim_matrix;
	SimHeapNode * sim_heap;
	int heap_size;
	set<int> indices;
	const int n;
	
};


inline
void SimilarityMatrix::move_node(int from, int to)
{
	SimHeapNode & s = sim_heap[to] = sim_heap[from];
	sim_matrix[s.i][s.j] = to;
	sim_matrix[s.j][s.i] = to;
	return;
}
